Moved all references to file descriptors out of the generic object
[wine] / tools / wineinstall
1 #!/bin/bash
2 # WINE Installation script
3 # Can do almost everything from compiling to configuring...
4 #
5 # Copyright 1999 Ove Kåven
6 #
7 # This library is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU Lesser General Public
9 # License as published by the Free Software Foundation; either
10 # version 2.1 of the License, or (at your option) any later version.
11 #
12 # This library is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
15 # Lesser General Public License for more details.
16 #
17 # You should have received a copy of the GNU Lesser General Public
18 # License along with this library; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
20 #
21
22 #--- defaults (change these if you are a packager)
23 CONFARGS=""                   # configure args, e.g. --prefix=/usr --sysconfdir=/etc
24 prefix=/usr/local             # installation prefix
25 sysconfdir=$prefix/etc        # where wine.conf and the global registry are supposed to be
26 bindir=$prefix/bin            # where winelib apps will be (or are) installed
27 libdir=$prefix/lib            # where libwine.so will be (or is) installed
28 exdir=documentation/samples   # where the sample system.ini resides
29 GCONF=$sysconfdir/wine.conf   # default path of the wine.conf global config file
30 LCONF=~/.wine/config          # default path of the local config file
31 BINDIST=no                    # whether called from a binary package config script
32 DOGLOBALCONF=auto             # whether to autogenerate wine.conf
33 DOLOCALCONF=auto              # whether to autogenerate localconf
34 DOWCHK=auto                   # whether to autoconfigure existing-windows installation
35 DOWINE=auto                   # whether to autoconfigure no-windows installation
36 DOREG=auto                    # whether to install default registry
37 DOAPP=auto                    # whether to install applications, distributed with Wine
38 SYSREG=yes                    # whether to make root's registry global (system-default)
39
40 # "make install" still installs the dlls into $libdir, but this may change in the future
41 # (DLLPATH should point to them if/when they are not in standard ld.so paths)
42 DLLPATH=$libdir/wine          # default path of the dll .so files (except libwine.so)
43
44 # this is only for existing-windows installs
45 WINECONF=tools/wineconf       # path to the wineconf perl script
46
47 # this is only for no-windows installs
48 WINEINI=$exdir/config         # path to the default wine config file (also used by wineconf)
49 WININI=/dev/null              # path to the default win.ini
50 SYSTEMINI=$exdir/system.ini   # path to the default system.ini
51 REGEDIT=programs/regedit/regedit       # path to the regedit winelib application
52 DEFREG=winedefault.reg        # path of the registry file to be fed to regedit
53 # CROOT=/var/wine             # path of the fake Drive C (asks user if not set)
54 DEFCAT=cat                    # program to cat $DEFREG with (some packages need zcat)
55 #--- end of defaults
56
57 # temporary files used by the installer
58 TMPCONF=/tmp/wineinstall.conf
59
60 # functions
61
62 function std_sleep {
63   sleep 1
64 }
65
66 function conf_question {
67   # parameters: $1 = importance, $2 = question-id, $3+ = message lines
68   # the first two parameters can be used by e.g. debconf in debian packages
69   # but here we just print the message
70   shift 2
71   echo
72   local LINE="$1"
73   while shift
74   do {
75     echo "$LINE"
76     LINE="$1"
77   }
78   done
79 }
80
81 function conf_reset_question {
82   # parameters: $1 = question-id
83   # this is used to flush any cached answers and "already-displayed" flags
84   shift # dummy command
85 }
86
87 function conf_yesno_answer {
88   unset ANSWER
89   while [ "$ANSWER" != 'yes' ] && [ "$ANSWER" != 'no' ]
90   do {
91     echo -n "$1"
92     read ANSWER
93   }
94   done
95 }
96
97 function conf_string_answer {
98   echo -n "$1"
99   read ANSWER
100 }
101
102 function create_windows_directories {
103   for tdir in "$CROOT/windows" "$CROOT/windows/system" \
104               "$CROOT/windows/command" \
105               "$CROOT/windows/Start Menu" "$CROOT/windows/Start Menu/Programs" \
106               "$CROOT/Program Files" "$CROOT/Program Files/Common Files" \
107               "$CROOT/windows/Profiles" "$CROOT/windows/Profiles/Administrator" \
108               "$CROOT/windows/Fonts" "$CROOT/windows/Start Menu/Programs/Startup"
109   do [ -d "$tdir" ] || mkdir "$tdir"
110   done
111   [ -f "$CROOT/windows/win.ini" ]    || cp "$WININI"    "$CROOT/windows/win.ini"
112   [ -f "$CROOT/windows/system.ini" ] || cp "$SYSTEMINI" "$CROOT/windows/system.ini"
113 }
114
115 #creates symbolic link in windows directory to installed winelib application
116 #parameters:
117 # - name of the installed winelib application
118 # - full path to application in the winelib directory
119 function link_app {
120   if [ "$WINEINSTALLED" = 'no' ]
121   then {
122     ln -sf $PWD/programs/$1/$1.exe.so $2
123   }
124   else {
125     ln -sf $libdir/wine/$1.exe.so $2
126   }
127   fi
128 }
129
130 #puts windows applications replacements to windows directories,
131 #configures them
132 function configure_wine_applications {
133   link_app start        "$CROOT/windows/command/start.exe"
134   link_app notepad      "$CROOT/windows/notepad.exe"
135   link_app regedit      "$CROOT/windows/regedit.exe"
136   link_app rundll32     "$CROOT/windows/rundll32.exe"
137   link_app wcmd         "$CROOT/windows/system/wcmd.exe"
138   link_app control      "$CROOT/windows/system/control.exe"
139   link_app winhelp      "$CROOT/windows/system/help.exe"
140   link_app notepad      "$CROOT/windows/system/notepad.exe"
141   link_app progman      "$CROOT/windows/system/progman.exe"
142   link_app regsvr32     "$CROOT/windows/system/regsvr32.exe"
143   link_app winemine     "$CROOT/windows/system/winmine.exe"
144   link_app winver       "$CROOT/windows/system/winver.exe"
145   link_app uninstaller  "$CROOT/windows/uninstall.exe"
146   link_app winhelp      "$CROOT/windows/winhelp.exe"
147   link_app winhelp      "$CROOT/windows/winhlp32.exe"
148 }
149
150 # startup...
151
152 echo "WINE Installer v0.74"
153 echo
154
155 if [ "$BINDIST" = 'no' ]
156 then {
157
158   if ! [ -f configure ]
159   then {
160     if [ -f ../configure ]
161     then {
162       pushd ..
163     }
164     else {
165       echo "You're running this from the wrong directory."
166       echo "Change to the Wine source's main directory and try again."
167       exit 1
168     }
169     fi
170   }
171   fi
172
173   if [ `whoami` == 'root' ]
174   then {
175     echo "You are running wineinstall as root, this is not advisable. Please rerun as a user."
176     echo "Aborting."
177     exit 1
178   }
179   fi
180
181   # check whether RPM installed, and if it is, remove any old wine rpm.
182   hash rpm &>/dev/null
183   RET=$?
184   if [ $RET -eq 0 ]; then
185     if [ -n "`rpm -qi wine 2>/dev/null|grep "^Name"`" ]; then
186       echo "Warning: Old Wine RPM install detected. Do you want to remove it first?"
187       conf_yesno_answer "(yes/no) "
188       if [ "$ANSWER" = 'yes' ]; then
189         echo "We need to remove the rpm as root, please enter your root password"
190         echo
191         echo Starting wine rpm removal...
192         su -c "rpm -e wine; RET=$?"
193         if [ $RET -eq 0 ]; then
194           echo Done.
195         else
196           echo "FAILED. Probably you aren't installing as root."
197           echo "Expect problems (library conflicts with existing install etc.)."
198         fi
199       else
200         echo "Sorry, I won't install Wine when an rpm version is still installed."
201         echo "(Wine support suffered from way too many conflicts between RPM"
202         echo "and source installs)"
203         echo "Have a nice day !"
204         exit 1
205       fi
206     fi
207   fi
208
209   # check whether wine binary still available
210   if [ -n "`which wine 2>/dev/null|grep '/wine'`" ]; then
211     echo "Warning !! wine binary (still) found, which may indicate"
212     echo "a (conflicting) previous installation."
213     echo "You might want to abort and uninstall Wine first."
214     std_sleep
215   fi
216
217   # run the configure script, if necessary
218
219   if [ -f config.cache ] && [ -f Makefile ] && [ Makefile -nt configure ]
220   then {
221     echo
222     echo "I see that WINE has already been configured, so I'll skip that."
223     std_sleep
224     # load configure results
225     . ./config.cache
226   }
227   else {
228     echo "Running configure..."
229     echo
230     if ! ./configure -C $CONFARGS
231     then {
232       echo
233       echo "Configure failed, aborting install."
234       rm -f config.cache
235       exit 1
236     }
237     fi
238     # load configure results
239     . ./config.cache
240     # make sure X was found
241     eval "$ac_cv_have_x"
242     if [ "$have_x" != "yes" ]
243     then {
244       echo "Install the X development headers and try again."
245       rm -f config.cache
246       exit 1
247     }
248     fi
249   }
250   fi
251
252   # now do the compilation and install, we need to always do this because we
253   # don't want the 'make install' command we might run to run 'make' as root
254   if [ `whoami` != 'root' ]
255   then {
256     # ask the user if they want to build and install wine
257     echo
258     echo "We need to install wine as root user, do you want us to build wine,"
259     echo "'su root' and install Wine?  Enter 'no' to continue without installing"
260     conf_yesno_answer "(yes/no) "
261     ROOTINSTALL="$ANSWER"
262
263     if [ "$ROOTINSTALL" = "yes" ]
264     then {
265       # start out with the basic command
266       sucommand="make install"
267
268       # if the user doesn't have $libdir in their ld.so.conf add this
269       # to our sucommand string
270       if [ -f /etc/ld.so.conf ]
271       then
272         if ! grep -qs "$libdir" /etc/ld.so.conf
273         then {
274           echo
275           echo "$libdir doesn't exist in your /etc/ld.so.conf, it will be added"
276           echo "when we perform the install..."
277           sucommand="$sucommand;echo $libdir>>/etc/ld.so.conf"
278         }
279         fi
280         # run ldconfig always just in case some updated files dont get linked
281         sucommand="$sucommand;$ac_cv_path_LDCONFIG"
282       fi
283     }
284     fi # [ "$ROOTINSTALL" = "yes" ]
285
286     echo
287
288     echo "Compiling WINE. Grab a lunch or two, rent a video, or whatever,"
289     echo "in the meantime..."
290     echo
291     std_sleep
292
293     # try to just make wine, if this fails 'make depend' and try to remake
294     if ! { make; }
295     then {
296       if ! { make depend && make; }
297       then {
298         echo
299         echo "Compilation failed, aborting install."
300         exit 1
301       }
302       fi
303     }
304     fi
305
306     if [ "$ROOTINSTALL" = "yes" ]
307     then {
308       echo
309
310       echo "Performing 'make install' as root to install binaries, enter root password"
311
312       std_sleep
313
314       if ! su root -c "$sucommand"
315       then {
316         echo
317         echo "Either you entered an incorrect password or we failed to run"
318         echo "'$sucommand' correctly."
319         echo "If you didn't enter an incorrect password then please report this"
320         echo "error and any steps to possibly reproduce it to"
321         echo "http://bugs.winehq.com/"
322         echo
323         echo "Installation failed, aborting."
324         exit 1
325       }
326       fi
327
328       echo
329
330       # see if wine is installed on the users system, if not prompt them
331       # and then exit
332       if [ ! `which wine` ]
333       then
334         echo "Could not find wine on your system.  Run wineinstall as root to install wine"
335         echo "before re-running wineinstall as a user."
336         echo
337         echo "Exiting wineinstall"
338         exit 1;
339       fi
340
341       WINEINSTALLED=yes
342     }
343     else {
344       # user didn't want to install wine so tell them about running from the
345       # current directory and set some stuff up for them
346
347       # setup to run from current directory
348       DLLPATH="$PWD/dlls"
349       if [ -z "$LD_LIBRARY_PATH" ]
350       then LD_LIBRARY_PATH="$PWD:$DLLPATH"
351       else LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PWD:$DLLPATH"
352       fi
353       export LD_LIBRARY_PATH
354       echo
355       echo "NOTE! To run Wine without installing, you must set the environment variable"
356       echo "LD_LIBRARY_PATH to $PWD:$DLLPATH"
357       echo "in your logon scripts."
358       echo
359
360       WINEINSTALLED=no
361     }
362     fi # [ "$ROOTINSTALL" = "yes" ]
363   }
364   fi # [ `whoami` != 'root' ]
365
366 }
367 fi # BINDIST
368
369 # now check whether we should generate wine.conf
370 if [ -z "$DOGLOBALCONF" ]
371 then
372   DOGLOBALCONF=auto
373 fi
374
375 if [ "$DOGLOBALCONF" = 'auto' ]
376 then {
377   # see if we already have a system wine.conf
378   if [ ! -f $GCONF ] && [ `whoami` = 'root' ]
379   then
380     DOGLOBALCONF=no
381     echo "Creation of a global config file is not supported in wineinstall at this"
382     echo "time.  When the configuration architecture is cleaned up this functionality"
383     echo "will be restored to wineinstall."
384     echo
385   fi
386 }
387 fi
388
389 if [ "$DOLOCALCONF" = 'auto' ]
390 then {
391   # see if the user is root, if so, explicitly ask them if they want a
392   # local config file
393   if [ `whoami` = 'root' ]
394   then
395     echo "You are running as root.  Do you want a local config file,"
396     echo "file, ~/.wine/config, created?"
397     conf_yesno_answer "(yes/no) "
398     DOLOCALCONF="$ANSWER"
399   else
400     # if the user has an existing config file ask them if they want us to
401     # overwrite it, otherwise just ask them if they want to create one
402     if [ -f "$LCONF" ]
403     then
404       echo "Found existing $LCONF, do you want to overwrite this"
405       echo "existing Wine configuration file?"
406       conf_yesno_answer "(yes/no) "
407       DOLOCALCONF="$ANSWER"
408       echo
409       if [ "$ANSWER" = "yes" ]
410       then
411       {
412         echo "Would you like to make a backup of this old config file?"
413         conf_yesno_answer "(yes/no) "
414         echo
415         if [ "$ANSWER" = "yes" ]
416         then
417         {
418           echo "Renaming $LCONF to $LCONF.old"
419           mv -f "$LCONF" "$LCONF.old"
420           echo
421         }
422         fi
423       }
424       fi
425     else
426     {
427       echo "Create local config file ~/.wine/config?"
428       conf_yesno_answer "(yes/no) "
429       DOLOCALCONF="$ANSWER"
430       echo
431       if [ "$ANSWER" = 'no' ]
432       then
433         conf_question high need_root \
434           "Aborting install. Try again as root to generate a system wine.conf."
435         exit 1
436       fi
437     }
438     fi
439   fi
440 }
441 fi
442
443 # generate $TMPCONF from existing windows install, if any
444 if [ "$DOLOCALCONF" = 'yes' ]
445 then {
446   if [ "$DOWCHK" = 'yes' ] || [ "$DOWCHK" = 'auto' ]
447   then {
448     echo -n "Searching for an existing Windows installation..."
449     if ! $WINECONF -inifile "$WINEINI" > $TMPCONF 2>/dev/null
450     then {
451       rm -f $TMPCONF > /dev/null
452
453       echo " not found. (no matching /etc/fstab mount entry found)"
454       conf_question low do_without_windows \
455        "Windows was not found on your system, so I assume you want" \
456        "a Wine-only installation. Am I correct?"
457       conf_yesno_answer "(yes/no) "
458       if [ "$ANSWER" = 'no' ]
459       then {
460         conf_question high windows_not_found \
461          "Aborting install. Make sure your Windows partition is mounted and try again," \
462          "or create $LCONF manually by copying from $WINEINI and adapting the drive paths."
463         exit 1
464       }
465       fi
466       DOWINE=yes
467     }
468     else {
469       echo " found."
470
471       conf_question low do_without_windows \
472        "Windows was found on your system, and so we can use the Windows" \
473        "Drive as our Wine drive. You may, however, wish to create a clean" \
474        "Wine install anyways."
475       conf_yesno_answer "Should I use the Windows drive for the Wine install? (yes/no) "
476       if [ "$ANSWER" = 'yes' ]
477       then {
478         conf_reset_question windows_found
479         conf_question low windows_found \
480          "Created $LCONF using your existing Windows installation." \
481          "You probably want to review the file, though."
482         DOWINE=no
483       }
484       else {
485         DOWINE=yes
486       }
487       fi
488     }
489     fi
490   }
491   elif [ "$DOWINE" = 'auto' ]
492   then DOWINE=yes
493   fi
494 }
495 elif [ "$DOWINE" = 'auto' ]
496 then
497   DOWINE=no
498 fi
499
500 # setup a no-windows installation, if necessary
501 if [ "$DOWINE" = 'yes' ]
502 then {
503   # set an appropriate DCROOT
504   if [ `whoami` != 'root' ]
505   then DCROOT=~/c
506   else DCROOT=/c
507   fi
508
509   conf_question low drivec_path \
510      "Configuring Wine without Windows." \
511      "Some fake Windows directories must be created, to hold any .ini files, DLLs," \
512      "start menu entries, and other things your applications may need to install." \
513      "Where would you like your fake C drive to be placed?"
514   while [ -z "$CROOT" ]
515   do {
516     conf_string_answer "(default is $DCROOT) "
517     [ -z "$ANSWER" ] && ANSWER="$DCROOT"
518     if ! [ -d "$ANSWER" ]
519     then {
520       if mkdir -p "$ANSWER"
521       then CROOT="$ANSWER"
522       else
523           echo "Directory $ANSWER can't be created !"
524           conf_reset_question drivec_path
525       fi
526     }
527     else CROOT="$ANSWER"
528     fi
529   }
530   done
531   echo "Configuring Wine for a no-windows install in $CROOT..."
532
533     create_windows_directories
534     configure_wine_applications
535
536   # create $LCONF using the default config file $WINEINI
537   if [ "$DOLOCALCONF" = 'yes' ]
538   then {
539     sed "s|\"Path\" = \"/c\"\$|\"Path\" = \"${CROOT}\"|" $WINEINI > $TMPCONF
540     conf_reset_question default_config
541     conf_question low default_config \
542      "Created $LCONF using default Wine configuration." \
543      "You probably want to review the file, though."
544   }
545   fi
546
547   # now we really should install the registry
548   if [ "$DOREG" = 'auto' ]
549   then DOREG=yes
550   fi
551 }
552 fi
553 echo
554
555 #install the local config file $LCONF
556 if [ "$DOLOCALCONF" = 'yes' ]
557 then
558   if [ ! -w ~/.wine ]
559   then
560     mkdir ~/.wine
561   fi
562   cp $TMPCONF $LCONF > /dev/null
563 else
564   DOREG=no
565 fi
566
567 #install the global config file $GCONF
568 if [ "$DOGLOBALCONF" = 'yes' ]
569 then
570   if [ ! -f $sysconfdir ]
571   then
572     mkdir -p $sysconfdir
573   fi
574
575   cp $TMPCONF $GCONF > /dev/null
576 fi
577
578 # check whether we need to install default registry
579 # (not to be done if windows registry exists)
580 if [ "$DOREG" = 'auto' ]
581 then {
582   CROOT=`sed -n '/^\[Drive C\]$/,/^\[.*\]$/ s/^\"Path\" = \"\(.*\)\"/\1/p' $LCONF`
583   echo "Checking for real Windows registry..."
584   if [ -f "$CROOT/windows/system.dat" ]
585   then DOREG=no
586   elif [ -f "$CROOT/windows/system32/config/system" ]
587   then DOREG=no
588   elif [ -f "$CROOT/WINNT/system32/config/system" ]
589   then DOREG=no
590   else DOREG=yes
591   fi
592   if [ "$DOREG" = 'yes' ]
593   then echo "Not found, default Wine registry will be installed."
594   else echo "Windows registry found, will not install default Wine registry."
595   fi
596   echo
597 }
598 fi
599
600 # install default registry entries
601 if [ "$DOREG" = 'yes' ]
602 then {
603   if [ "$BINDIST" = 'no' ]
604   then {
605     echo "Compiling regedit..."
606     (cd programs/regedit; make)
607     echo
608   }
609   fi
610   echo "Preparing to install default Wine registry entries..."
611
612   # edit config files so we don't have to run regedit under X
613   mv $LCONF $LCONF.orig
614   sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"ttydrv\"/" $LCONF.orig > $LCONF
615
616   echo "Installing default Wine registry entries..."
617   echo
618   if ! $REGEDIT $DEFREG > /dev/null
619   then {
620     echo "Registry install failed."
621     mv $LCONF.orig $LCONF
622     conf_reset_question regedit_error
623     conf_question high regedit_error
624     exit 1
625   }
626   else {
627     echo
628     echo "Registry entries successfully installed."
629     mv $LCONF.orig $LCONF
630   }
631   fi
632   if [ "$SYSREG" = 'auto' ]
633   then SYSREG=yes
634   fi
635 }
636 fi
637
638 # make root's registry global, if desired
639 if [ `whoami` = 'root' ] && [ "$DOREG" = 'yes' ] && [ "$SYSREG" = 'yes' ]
640 then {
641   [ -d ~/.wine ] || mkdir ~/.wine
642   if ! [ -f $sysconfdir/wine.userreg ]
643   then {
644     echo "Linking root's user registry hive to the global registry..."
645     [ -f ~/.wine/wine.userreg ] && cp ~/.wine/wine.userreg $sysconfdir/wine.userreg
646     ln -sf $sysconfdir/wine.userreg ~/.wine/wine.userreg
647   }
648   fi
649   if ! [ -f $sysconfdir/wine.systemreg ]
650   then {
651     echo "Linking root's system registry hive to the global registry..."
652     [ -f ~/.wine/system.reg ] && cp ~/.wine/system.reg $sysconfdir/wine.systemreg
653     ln -sf $sysconfdir/wine.systemreg ~/.wine/system.reg
654   }
655   fi
656 }
657 fi
658
659 # cleanup any temporary files that may remain
660 if [ -f $TMPCONF ]
661 then rm -f $TMPCONF
662 fi
663
664
665 # it's a wrap
666 echo
667 echo "Installation complete for now. Good luck (this is still alpha software)."
668 echo "If you have problems with WINE, please read the documentation first,"
669 echo "as many kinds of potential problems are explained there."
670
671 exit 0